#!/usr/bin/python
# $Id: hsv_to_rgb.py,v 1.4 2005/09/13 05:21:01 oohara Exp $

import sys

def hsv_to_rgb(hsv):
    hue = hsv[0]
    saturation = hsv[1]
    value = hsv[2]
    if hue < 0:
        hue = 0
    if hue > 360:
        hue = 360
    if saturation < 0:
        saturation = 0
    if saturation > 100:
        saturation = 100
    if value < 0:
        value = 0
    if value > 100:
        value = 100
    red = 0
    green = 0
    blue = 0
    if hue < 60:
        red = 255
        green = 255 * hue / 60
        blue = 0
    elif hue < 120:
        red = 255 * (120 - hue) / 60
        green = 255
        blue = 0
    elif hue < 180:
        red = 0
        green = 255
        blue = 255 * (hue- 120) / 60
    elif hue < 240:
        red = 0
        green = 255 * (240 - hue) / 60
        blue = 255
    elif hue < 300:
        red = 255 * (hue - 240) / 60
        green = 0
        blue = 255
    else:
        red = 255
        green = 0
        blue = 255 * (360 - hue) / 60
    if red < 0:
        red = 0
    if red > 255:
        red = 255
    if green < 0:
        green = 0
    if green > 255:
        green = 255
    if blue < 0:
        blue = 0
    if blue > 255:
        blue = 255
    red = (red * saturation + 255 * (100 - saturation)) / 100
    green = (green * saturation + 255 * (100 - saturation)) / 100
    blue = (blue * saturation + 255 * (100 - saturation)) / 100
    if red < 0:
        red = 0
    if red > 255:
        red = 255
    if green < 0:
        green = 0
    if green > 255:
        green = 255
    if blue < 0:
        blue = 0
    if blue > 255:
        blue = 255
    red = red * value / 100
    green = green * value / 100
    blue = blue * value / 100
    if red < 0:
        red = 0
    if red > 255:
        red = 255
    if green < 0:
        green = 0
    if green > 255:
        green = 255
    if blue < 0:
        blue = 0
    if blue > 255:
        blue = 255
    return ((red, green, blue), (hue, saturation, value))

if __name__ == "__main__":
    if len(sys.argv) < 4:
        print "usage: %s hue saturation value" % (sys.argv[0])
        sys.exit(1)
    hue = int(sys.argv[1])
    saturation = int(sys.argv[2])
    value = int(sys.argv[3])
    result = hsv_to_rgb((hue, saturation, value))
    print "hue, saturation, value: %d, %d, %d" % result[1]
    print "red, green, blue: %d, %d, %d" % result[0]
