#!/usr/bin/python
# $Id: markov.py,v 1.20 2005/09/16 13:02:39 oohara Exp $

import sys
import re
import random

class markov:
    def __init__(self, filename):
        self.previous = None
        self.dict = {}
        r = re.compile("[a-zA-Z](?:[\-a-zA-Z\']*[a-zA-Z]+)*[.,;:]?")
        word_from = None
        word_to = None
        f = file(filename, "r")
        for line in f:
            for word in r.findall(line):
                assert word != None
                assert word != ""
                word_to = word
                if word_from == None:
                    pass
                else:
                    if not (self.dict.has_key(word_from)):
                        self.dict[word_from] = []
                    l = self.dict[word_from]
                    l.append(word_to)
                word_from = word_to
        f.close()
        assert len(self.dict) > 0
    def next(self):
        assert len(self.dict) > 0
        if self.dict.has_key(self.previous):
            word = random.choice(self.dict[self.previous])
        else:
            word = random.choice(self.dict.keys())
        assert word != None
        assert word != ""
        self.previous = word
        return word

if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "usage: %s file" % sys.argv[0]
        sys.exit(1)
    m = markov(sys.argv[1])
    for i in range(100):
        print m.next()
